/*
 *	DVI commands for DVISVG
 */

#define DVI_SET_CHAR_0   0x00     /* characters and rules */
#define DVI_SET_CHAR_127 0x7f
#define DVI_SET_1        0x80
#define DVI_SET_2        0x81     /* not used in TeX */ 
#define DVI_SET_3        0x82     /* not used in TeX */
#define DVI_SET_4        0x83     /* not used in TeX */
#define DVI_SET_RULE     0x84
#define DVI_PUT_1        0x85
#define DVI_PUT_2        0x86     /* not used in TeX */
#define DVI_PUT_3        0x87     /* not used in TeX */
#define DVI_PUT_4        0x88     /* not used in TeX */
#define DVI_PUT_RULE     0x89

#define DVI_NOP       0x8a        /* TBN: not used   */
#define DVI_BOP       0x8b
#define DVI_EOP       0x8c

#define DVI_PUSH      0x8d        /* stack           */
#define DVI_POP       0x8e

#define DVI_RIGHT_1   0x8f        /* horizontal shifts   */
#define DVI_RIGHT_2   0x90
#define DVI_RIGHT_3   0x91
#define DVI_RIGHT_4   0x92
#define DVI_W0        0x93
#define DVI_W_1       0x94
#define DVI_W_2       0x95
#define DVI_W_3       0x96
#define DVI_W_4       0x97
#define DVI_X0        0x98
#define DVI_X_1       0x99
#define DVI_X_2       0x9a
#define DVI_X_3       0x9b
#define DVI_X_4       0x9c

#define DVI_DOWN_1    0x9d       /* vertical shifts    */
#define DVI_DOWN_2    0x9e
#define DVI_DOWN_3    0x9f
#define DVI_DOWN_4    0xa0
#define DVI_Y0        0xa1
#define DVI_Y_1       0xa2
#define DVI_Y_2       0xa3
#define DVI_Y_3       0xa4
#define DVI_Y_4       0xa5
#define DVI_Z0        0xa6
#define DVI_Z_1       0xa7
#define DVI_Z_2       0xa8
#define DVI_Z_3       0xa9
#define DVI_Z_4       0xaa

#define DVI_FNT_NUM_0   0xab    /* fonts       */
#define DVI_FNT_NUM_63  0xea
#define DVI_FNT_1       0xeb
#define DVI_FNT_2       0xec    /* not used in standart TeX */
#define DVI_FNT_3       0xed    /* not used in standart TeX */
#define DVI_FNT_4       0xee    /* not used in standart TeX */

#define DVI_XXX_1     0xef      /* specials    */
#define DVI_XXX_2     0xf0
#define DVI_XXX_3     0xf1
#define DVI_XXX_4     0xf2

#define DVI_FNT_DEF_1 0xf3
#define DVI_FNT_DEF_2 0xf4      /* not used in standart TeX */
#define DVI_FNT_DEF_3 0xf5      /* not used in standart TeX */
#define DVI_FNT_DEF_4 0xf6      /* not used in standart TeX */

#define DVI_PRE       0xf7
#define DVI_POST      0xf8
#define DVI_POST_POST 0xf9

#define DVI_PADDING   0xdf

/*
 *	end of dvicom.h
 */
