/*
 *  DVIPAGE section
 */

#include <stdio.h>
#include <stdlib.h> /* for malloc */
#include "dvicom.h"
#include "dvistr.h"
#include "dstypes.h"
#include "xmlsvg.h"

/* post_s global in dvibase.c */
GLOBAL int post_s;

/* chartable, metricstable, dvitfminit global in dvitfm.c */
GLOBAL BYTE *chartable[256];
GLOBAL float *metricstable[256];
GLOBAL dvitfminit(FILE *log_out);
GLOBAL dvitfmfree(FILE *log_out);
GLOBAL dvitfm(char *tfmfile, int k, FILE *log_out);

GLOBAL int svgfonts(char *f2s_path, char *svgfontfile, char *f2s_enc,
			 dvi_fnt_def_k2_struct **fnt_def_k2, FILE *log_out);

/* global in dvisvg.c */
GLOBAL int sel_page;

/*
 * bfrchrstate for SET_CHAR, SET_1
 */
LOCAL int bfrchrstate;
LOCAL int currfnt;
/* dvi_c for WHILE
 * dvi_d for SET_1, PUT_1, FNT_1
 *           BOP dvi_d = bop.c[0]
 *           SET_CHAR dvi_d = dvi_c
 *           FNT_NUM_0..FNT_NUM_63 dvi_d = currfnt - 171
 * dvi_e for SET_RULE, PUT_RULE */
LOCAL int dvi_c, dvi_d, dvi_e;
LOCAL void dvi_set_char(FILE *log_out);
LOCAL void dvi_set_1(FILE *dvi_inp, FILE *log_out);
LOCAL void dvi_put_1(FILE *dvi_inp, FILE *log_out);

LOCAL void dvi_set_rule(FILE *dvi_inp, FILE *log_out);
LOCAL void dvi_put_rule(FILE *dvi_inp, FILE *log_out);

LOCAL dvi_fnt_def_k2_struct *fnt_def_k2[256];
LOCAL void fontinit2();
LOCAL void fontfree2(FILE* log_out);
LOCAL int dvi_fnt_def2(FILE *dvi_inp, FILE *log_out);

LOCAL void dvi_fnt_num(FILE *log_out);
LOCAL void dvi_fnt_1(FILE *dvi_inp, FILE *log_out);

LOCAL dvi_state_struct state;
LOCAL void dvi_shift(FILE *dvi_inp);

LOCAL int stack_top = 0;
LOCAL dvi_state_struct *stack;
LOCAL int dvi_push(FILE *log_out);
LOCAL int dvi_pop(FILE *log_out);

/* readed in dvibase.c */
LOCAL dvi_bop_struct bop;
LOCAL dvi_bop(FILE *dvi_inp, FILE *log_out);

LOCAL void dvi_shift_debug(FILE *log_out);
LOCAL void dvi_print_state(dvi_state_struct state, FILE *log_out);

/* XXX for \special */
LOCAL int xxx_k;
LOCAL char *xxx_x;
LOCAL void dvi_xxx_1(FILE *dvi_inp, FILE *log_out);
LOCAL void dvi_xxx_2(FILE *dvi_inp, FILE *log_out);

/*
 * DVIPAGE function
 */

int dvipage(FILE *dvi_inp, char *dvisvgcnf, char *svgfontfile,
			FILE *svg_out, FILE *log_out) {
	int pp, qq; 

	fprintf(log_out, "#### dvipage.c\n");
/*
 * STACK ALLOC
 * post_s from dvibase.c
 * stack_top  == 0 stack is empty
 * at begining must be stack_top = 0
 * stack_top must be >=0 && <= post_s
 * at the end must be stack_top == 0 */
	fprintf(log_out, "Stack depth: %d", post_s);
	stack = (dvi_state_struct *)
			malloc(sizeof(dvi_state_struct) * post_s);
/* font */
	fontinit2();
/* tfm */
	dvitfminit(log_out);

	printf("Pages:");
	fflush(stdout);
	while((dvi_c = getc(dvi_inp)) != DVI_POST) {
/*  debug
		printf("[%x]", dvi_c);
		fflush(stdout);
		fflush(log_out);
 */
		if(dvi_c >= DVI_SET_CHAR_0 && dvi_c <= DVI_SET_CHAR_127)
			dvi_set_char(log_out);
		else if(dvi_c >= DVI_FNT_NUM_0 && dvi_c <= DVI_FNT_NUM_63)
					dvi_fnt_num(log_out);
		else {
		if(dvi_c >= DVI_RIGHT_1 && dvi_c <= DVI_Z_4)
			dvi_shift(dvi_inp);
		else switch(dvi_c) {
				case DVI_SET_1:
					dvi_set_1(dvi_inp, log_out); break;
				case DVI_SET_RULE:
					dvi_set_rule(dvi_inp, log_out); break;
				case DVI_PUT_1:
					dvi_put_1(dvi_inp, log_out); break;
				case DVI_PUT_RULE:
					dvi_put_rule(dvi_inp, log_out); break;
				case DVI_NOP:
					fprintf(log_out, "<nop>"); break;
				case DVI_BOP:
					dvi_bop(dvi_inp, log_out); break;
				case DVI_EOP:
					fprintf(log_out, "\neop");
					if(bop.c[0] == sel_page) printf(")");
					break;
				case DVI_PUSH:
					if(dvi_push(log_out) == 100) return 100; break;
				case DVI_POP:
					if(dvi_pop(log_out) == 101) return 101; break;
				case DVI_FNT_1:
					dvi_fnt_1(dvi_inp, log_out); break;
				case DVI_XXX_1:
					dvi_xxx_1(dvi_inp, log_out); break;
				case DVI_XXX_2:
					dvi_xxx_2(dvi_inp, log_out); break;
				case DVI_FNT_DEF_1:
					if(dvi_fnt_def2(dvi_inp, log_out) == 200) return 200;
					break;
				default:
					printf("\n??(%x)\n",(unsigned char) dvi_c);
					return 102;
		}
		dvi_shift_debug(log_out);
	}
	if(bop.c[0] == sel_page)
		svgout(dvi_c, dvi_d, dvi_e, state, bfrchrstate, svg_out, log_out);
/*
	dvi_print_state(dvi_c, state, log_out);
 */
	}

/*
 * LOGOUT & STDOUT
 */
	printf("\n");
	fprintf(svg_out,svg_svg2);
	fprintf(log_out, "\n");

/*
 * FREE
 */
	dvitfmfree(log_out);
	free(stack);

/* SVGFONTS */
	svgfonts(dvisvgcnf, svgfontfile, "TeXUTF8Encoding", fnt_def_k2, log_out);

/* debug
	for(pp=0; pp<256; pp++) {
		if(fnt_def_k2[pp] != NULL) {
			if(fnt_def_k2[pp]->usedchars != NULL) {
				printf("\nFnt:%d\nSymbols:", pp);
				for(qq = 0; qq <256; qq++) {
					if(fnt_def_k2[pp]->usedchars[qq] ==1) {
						printf("%d ",qq);
					}
				}
			}
		}
	}
 */

/*
 * FREE
 */
	fontfree2(log_out);

	return 0;
}

LOCAL void fontinit2() {
	int pp;

	for(pp=0; pp<256; pp++) fnt_def_k2[pp] = NULL;
}

LOCAL void fontfree2(FILE *log_out) {
	int pp;

	fprintf(log_out, "\ndvipagefontfree:", pp);
	for(pp=0; pp<256; pp++)
	if(fnt_def_k2[pp] != NULL) {
			fprintf(log_out, " %d", pp);
			free(fnt_def_k2[pp]->n);
			free(fnt_def_k2[pp]->usedchars);
			free(fnt_def_k2[pp]);
	}
	fprintf(log_out, "\n");
}

LOCAL int dvi_fnt_def2(FILE *dvi_inp, FILE *log_out) {
	int fnt_c;
	dvi_fnt_def_struct fnt_def;
	int pp;
	WORD fnt_def_al;

	fprintf(log_out, "\nFNT_DEF_1: ");
	fnt_def.k = napln1(dvi_inp); 
	fnt_def.c = napln4(dvi_inp); 
	fnt_def.s = napln4(dvi_inp); 
	fnt_def.d = napln4(dvi_inp); 
	fnt_def.a = napln1(dvi_inp); 
	fnt_def.l = napln1(dvi_inp); 
	fnt_def_al = fnt_def.l + fnt_def.a;
	fprintf(log_out,
		"k:%2d, c:%10u, s:%d, d:%d, a:%d, l:%d ",
		fnt_def.k, fnt_def.c, fnt_def.s,
		fnt_def.d, fnt_def.a, fnt_def.l);
	fnt_def.n = (char *)
			malloc(sizeof(char) * (fnt_def_al+1));
	for(pp = 0; pp < fnt_def_al; pp++)
			fnt_def.n[pp] = (char) napln1(dvi_inp);
	fnt_def.n[fnt_def_al] = '\0';
	printf("*");
	fprintf(log_out, "n:%s", fnt_def.n);
	fnt_def_k2[fnt_def.k] =
			(dvi_fnt_def_k2_struct *)
			malloc(sizeof(dvi_fnt_def_k2_struct));
	fnt_def_k2[fnt_def.k]->c = fnt_def.c;
	fnt_def_k2[fnt_def.k]->s = fnt_def.s;
	fnt_def_k2[fnt_def.k]->d = fnt_def.d;
	fnt_def_k2[fnt_def.k]->sd = (float) fnt_def.s/fnt_def.d;
	fprintf(log_out, "\ns/d: %f\n", fnt_def_k2[fnt_def.k]->sd);
	fprintf(log_out, "n:%s", fnt_def.n);

	fnt_def_k2[fnt_def.k]->n = (char *) malloc(strlen(fnt_def.n));
/* font metrics */
	strcpy(fnt_def_k2[fnt_def.k]->n, fnt_def.n);
	if(dvitfm(fnt_def.n, fnt_def.k, log_out) != 0) {
			free(fnt_def.n);
			return 200;
	}
/* tfmprintD(chartable[fnt_def.k], metricstable[fnt_def.k]); */
	free(fnt_def.n);
/* used characters */
	fnt_def_k2[fnt_def.k]->usedchars = NULL;
	if(bop.c[0] == sel_page) {
		fnt_def_k2[fnt_def.k]->usedchars = (BYTE *) malloc(256*sizeof(BYTE));
		for(pp = 0; pp < 256; pp++)
			fnt_def_k2[fnt_def.k]->usedchars[pp] = 0;
	}
	return 0;
}

LOCAL void dvi_set_char(FILE *log_out) {
	dvi_d = dvi_c;
	if(dvi_c < 32) {
		fprintf(log_out, "^%c", dvi_c+64);
	}
	else {
		fprintf(log_out, "%c", dvi_c);
	}
	if(bop.c[0] == sel_page)
		fnt_def_k2[currfnt]->usedchars[dvi_d]=1;
	bfrchrstate = state.h;
	state.h += (int)
		(metricstable[currfnt][chartable[currfnt][dvi_c]]
		* fnt_def_k2[currfnt]->sd
		* 65536);
}


LOCAL void dvi_set_1(FILE *dvi_inp, FILE *log_out) {
	fprintf(log_out, "<set1>");
	dvi_d = napln1(dvi_inp);
	if(bop.c[0] == sel_page)
		fnt_def_k2[currfnt]->usedchars[dvi_d]=1;
	bfrchrstate = state.h;
	state.h += (int)
		(metricstable[currfnt][chartable[currfnt][dvi_d]]
		* fnt_def_k2[currfnt]->sd
		* 65536);
}

LOCAL void dvi_put_1(FILE *dvi_inp, FILE *log_out) {
	fprintf(log_out, "<put1>");
	dvi_d = napln1(dvi_inp, log_out);
	if(bop.c[0] == sel_page)
		fnt_def_k2[currfnt]->usedchars[dvi_d]=1;
	bfrchrstate = state.h;
}

/*
 * ?? position sub 171
 */
LOCAL void dvi_fnt_num(FILE *log_out) {
	int pp;

	currfnt = dvi_c-171;
	dvi_d = currfnt;
	fprintf(log_out, "\n[fnt_num_%d]", dvi_d);
}

LOCAL void dvi_fnt_1(FILE *dvi_inp, FILE *log_out) {
	int pp;

	fprintf(log_out, "[fnt_1_%d]",
	currfnt = napln1(dvi_inp));
	dvi_d = currfnt;
}

/*
 * RULE a = width, b = height
 */
LOCAL void dvi_set_rule(FILE *dvi_inp, FILE *log_out) {
	WORD rule_a, rule_b;
	fprintf(log_out, "<setrule>");
	rule_a = napln4(dvi_inp);
	rule_b = napln4(dvi_inp);
	dvi_d = rule_a;
	dvi_e = rule_b;
	state.h += rule_a;
}

LOCAL void dvi_put_rule(FILE *dvi_inp, FILE *log_out) {
	WORD rule_a, rule_b;
	fprintf(log_out, "<putrule>");
	rule_a = napln4(dvi_inp);
	rule_b = napln4(dvi_inp);
	dvi_d = rule_a;
	dvi_e = rule_b;
}

LOCAL void dvi_shift(FILE *dvi_inp) {
	switch(dvi_c) {
		case DVI_RIGHT_1: state.h += napln1(dvi_inp); break;
		case DVI_RIGHT_2: state.h += napln2(dvi_inp); break;
		case DVI_RIGHT_3: state.h += napln3(dvi_inp); break;
		case DVI_RIGHT_4: state.h += napln4(dvi_inp); break;
		case DVI_W0:  state.h += state.w; break;
		case DVI_W_1: state.h += (state.w = napln1(dvi_inp)); break;
		case DVI_W_2: state.h += (state.w = napln2(dvi_inp)); break;
		case DVI_W_3: state.h += (state.w = napln3(dvi_inp)); break;
		case DVI_W_4: state.h += (state.w = napln4(dvi_inp)); break;
		case DVI_X0:  state.h += state.x; break;
		case DVI_X_1: state.h += (state.x = napln1(dvi_inp)); break;
		case DVI_X_2: state.h += (state.x = napln2(dvi_inp)); break;
		case DVI_X_3: state.h += (state.x = napln3(dvi_inp)); break;
		case DVI_X_4: state.h += (state.x = napln4(dvi_inp)); break;
		case DVI_DOWN_1: state.v += napln1(dvi_inp); break;
		case DVI_DOWN_2: state.v += napln2(dvi_inp); break;
		case DVI_DOWN_3: state.v += napln3(dvi_inp); break;
		case DVI_DOWN_4: state.v += napln4(dvi_inp); break;
		case DVI_Y0:  state.v += state.y; break;
		case DVI_Y_1: state.v += (state.y = napln1(dvi_inp)); break;
		case DVI_Y_2: state.v += (state.y = napln2(dvi_inp)); break;
		case DVI_Y_3: state.v += (state.y = napln3(dvi_inp)); break;
		case DVI_Y_4: state.v += (state.y = napln4(dvi_inp)); break;
		case DVI_Z0:  state.v += state.z; break;
		case DVI_Z_1: state.v += (state.z = napln1(dvi_inp)); break;
		case DVI_Z_2: state.v += (state.z = napln2(dvi_inp)); break;
		case DVI_Z_3: state.v += (state.z = napln3(dvi_inp)); break;
		case DVI_Z_4: state.v += (state.z = napln4(dvi_inp)); break;
	}
}

LOCAL int dvi_push(FILE *log_out) {
	fprintf(log_out, "<push>");
	if(stack_top > post_s) {
		printf("\nStack overflow\n");
		return 100;
	}
	else {
		stack[stack_top].h = state.h;
		stack[stack_top].v = state.v;
		stack[stack_top].w = state.w;
		stack[stack_top].x = state.x;
		stack[stack_top].y = state.y;
		stack[stack_top].z = state.z;
		stack_top++;
	}
}

LOCAL int dvi_pop(FILE *log_out) {
	fprintf(log_out, "<pop>");
	if(stack_top < 0) {
		printf("\nStack underflow\n");
		return 101;
	}
	else {
		stack_top--;
		state.h = stack[stack_top].h;
		state.v = stack[stack_top].v;
		state.w = stack[stack_top].w;
		state.x = stack[stack_top].x;
		state.y = stack[stack_top].y;
		state.z = stack[stack_top].z;
	}
}

/* maximum malloc for 2^8 characters */
LOCAL void dvi_xxx_1(FILE *dvi_inp, FILE *log_out) {
	int pp;
	xxx_k = napln1(dvi_inp);
	xxx_x = (char *) malloc(sizeof(char)*(xxx_k+1));
	for(pp = 0; pp < xxx_k; pp++)
				  xxx_x[pp] = (char) napln1(dvi_inp);
	xxx_x[xxx_k] = '\0';
	fprintf(log_out, "xxx_1:%s",xxx_x);
	free(xxx_x);
}

LOCAL dvi_bop(FILE *dvi_inp, FILE *log_out) {
	int pp;
	state.h=0, state.v=0;
	state.w=0, state.x=0;
	state.y=0, state.z=0;
	for(pp=0; pp<10; pp++)
		bop.c[pp] = napln4(dvi_inp);
	bop.p = napln4(dvi_inp);
	if(bop.c[0] == sel_page) printf("(");
	printf(".");
	fflush(stdout);
	fprintf(log_out, "\nbop: Page %d\n", bop.c[0]);
	dvi_d = bop.c[0];
}

/* maximum malloc for 2^16 characters */
LOCAL void dvi_xxx_2(FILE *dvi_inp, FILE *log_out) {
	int pp;
	xxx_k = napln2(dvi_inp);
	xxx_x = (char *) malloc(sizeof(char)*(xxx_k+1));
	for(pp = 0; pp < xxx_k; pp++)
				  xxx_x[pp] = (char) napln1(dvi_inp);
	xxx_x[xxx_k] = '\0';
	fprintf(log_out, "xxx_2:%s",xxx_x);
	free(xxx_x);
}

LOCAL char *dvicmd[28] = {
	"<r1>", "<r2>", "<r3>", "<r4>",
	"<w0>", "<w1>", "<w2>", "<w3>", "<w4>",
	"<x0>", "<x1>", "<x2>", "<x3>", "<x4>",
	"<d1>", "<d2>", "<d3>", "<d4>",
	"<y0>", "<y1>", "<y2>", "<y3>", "<y4>",
	"<z0>", "<z1>", "<z2>", "<z3>", "<z4>"
};

LOCAL void dvi_shift_debug(FILE *log_out) {
	if(dvi_c >= DVI_RIGHT_1 && dvi_c <= DVI_Z_4)
		fprintf(log_out, "%s", dvicmd[dvi_c-DVI_RIGHT_1]);
}

LOCAL void dvi_print_state(dvi_state_struct state, FILE *log_out) {
	if(dvi_c >= DVI_FNT_NUM_0 && dvi_c <= DVI_FNT_NUM_63) ;
	else fprintf(log_out,
		" == h:%d v:%d; horiz w:%d x:%d, vert y:%d z:%d\n",
	    state.h, state.v, state.w,
		state.x, state.y, state.z);
}

/*
 *  DVIPAGE section
 *  vim:ts=4:
 */
