/*
 *	DVI related structures for DVISVG
 */

#include "dstypes.h"

typedef struct {
	WORD i;		/* DVI version	 */             
	WORD p;         /* pointer on BOP on last page */
	WORD num;	/* numerator     */
	WORD den;	/* denominator   */
	WORD mag; 	/* magnification */
	WORD k;		/* length of string */
        char *x;	/* string */
} dvi_pre_struct;

typedef struct {
	WORD i;		/* same as dvi_pre_struct */
	WORD p;		/* */
	WORD num;	/* */
	WORD den;	/* */
	WORD mag;	/* */
	WORD l;		/* height of the heighest page */
	WORD u;		/* same for width 	       */
	WORD s;		/* stack depth	 	  */
	WORD t;		/* number of pages 	  */
} dvi_post_struct;

typedef struct {
	WORD q;		/* position of DVI_POST 	*/
	WORD i;		/* dvi version			*/
} dvi_post_post_struct;

typedef struct {
	WORD c[10];	/* pages counters */
	WORD p;		/* position of previos page	*/
} dvi_bop_struct;

typedef struct {
	WORD k;	         /* until now undefined number of font 	*/
	WORD c;          /* c control sum 			*/         
        WORD s;          /* s size        			*/         
	WORD d;          /* d design size 			*/         
	WORD a;          /* a length of prefix 			*/    
	WORD l;          /* l length of name   			*/     
	char *n;         /* n name				*/
} dvi_fnt_def_struct;

typedef struct {
	WORD c;          /* c control sum 			*/         
        WORD s;          /* s size        			*/         
	WORD d;          /* d design size 			*/         
	char *n;         /* n name				*/
} dvi_fnt_def_k_struct;

typedef struct {
	WORD c;          /* c control sum 			*/         
        WORD s;          /* s size        			*/         
	WORD d;          /* d design size 			*/         
	float sd;
	BYTE *usedchars;
	char *n;         /* n name				*/
} dvi_fnt_def_k2_struct;

typedef struct {
	SWORD h, v;	/* state horizontal vertical */
	SWORD w, x;	/* horizontal shift 	     */
	SWORD y, z;	/* vertical shift	     */
} dvi_state_struct;

/*
 *	end of dvistr.h
 */
