/*
 *   SVGFONTS section
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>  /* for system */
#include <kpathsea/tex-file.h>
#include "dvistr.h"
#include "dstypes.h"
#include "xmlsvg.h"

LOCAL char fnt_pfb[WORDLEN];
LOCAL int processline(char dd[INPBUF]);

LOCAL char fnt_dvi[WORDLEN];
LOCAL char fnt_ps[WORDLEN];

LOCAL int psmap(char *srchfnt, FILE *in, FILE *log_out);

LOCAL int
svgfontgen(char *f2s_file_enc, char *f2s_enc, char *f2s_sym, char *f2s_prg,
		   char *f2s_font_out, FILE *log_out);

LOCAL int symbols_pp;
LOCAL char symbols_string[1024];
LOCAL void symbols(int number) {
	static char string[32];

	sprintf(string, "%d ", number);
	sprintf(&symbols_string[symbols_pp], "%s", string);
	/* printf("sym: %d %s\n", symbols_pp, symbols_string); */
	symbols_pp += strlen(string);
}

int svgfonts(char *f2s_path, char *svgfontfile, char *f2s_enc,
			 dvi_fnt_def_k2_struct **fnt_def_k2, FILE *log_out) {
    char f2s_prg_file[] = "font2svg.ps";
	char f2s_enc_file[] = "font2svg.enc";
    char map_file[] = "dvisvg.map";
	char f2s_prg_file_path[MAXPATH];
	char f2s_enc_file_path[MAXPATH];
	char map_file_path[MAXPATH];
	FILE *map_file_in;
	FILE *tmp_svg_font;
	FILE *svg_font_out;
	int fnt_c;
	int pp, qq;

	kpse_set_program_name("dvisvg", NULL);
	printf("SVG Fonts:");
	sprintf(f2s_prg_file_path, "%s/%s", f2s_path, f2s_prg_file);
	sprintf(f2s_enc_file_path, "%s/%s", f2s_path, f2s_enc_file);
	sprintf(map_file_path, "%s/%s", f2s_path, map_file);

	if((map_file_in = fopen(map_file_path, "r")) == NULL) {
		printf("Can not open MAP file %s.\n", map_file_path);
		return 2;
	}

	for(pp=0; pp<256; pp++) {
		if(fnt_def_k2[pp] != NULL) {
			if(fnt_def_k2[pp]->usedchars != NULL) {
				printf("*");
				fprintf(log_out, "\nFnt:%d\nSymbols:", pp);
				symbols_pp=0;
				for(qq = 0; qq <256; qq++) {
					if(fnt_def_k2[pp]->usedchars[qq] ==1) {
						fprintf(log_out, "%d ", qq);
						symbols(qq);
					}
				}
				if(psmap(fnt_def_k2[pp]->n, map_file_in, log_out) == 0) {
					printf("Mappings for %s not founded.\n",
							fnt_def_k2[pp]->n);
					return 3;
				}
				/* if founded fnt_dvi, fnt_ps, fnt_pfb are setted */
				svgfontgen(f2s_enc_file_path, f2s_enc,
						   symbols_string,
						   f2s_prg_file_path,
						   fnt_def_k2[pp]->n, log_out);
			}
		}
	}
	printf("\nOpening file: %s (w).\n", svgfontfile);
	if((svg_font_out = fopen(svgfontfile, "w")) == NULL) {
			printf("\nCan not open %s as SVG font output file.\n", svgfontfile);
			return 4;
	}
	printf("SVG Fonts:");
	fprintf(svg_font_out, xml_pro, XMLVER, XMLENC, XMLSA);
	fprintf(svg_font_out, svg_svg_fnt, SVGVER, SVGNS);
	fprintf(svg_font_out, svg_defs);

	for(pp=0; pp<256; pp++) {
		if(fnt_def_k2[pp] != NULL) {
			if(fnt_def_k2[pp]->usedchars != NULL) {
					printf("*");
					if((tmp_svg_font = fopen(fnt_def_k2[pp]->n, "r")) == NULL) {
							printf("\nCan not open generated SVG font %s.\n",
									fnt_def_k2[pp]->n);
							return 5;
					}
					while((fnt_c = getc(tmp_svg_font)) != EOF)
						putc(fnt_c, svg_font_out);
					fclose(tmp_svg_font);
					if(remove(fnt_def_k2[pp]->n) != 0) {
							printf("\nCan not remove generated SVG font %s.\n",
									fnt_def_k2[pp]->n);
					}
			}
		}
	}

	fprintf(svg_font_out, svg_defs2);
	fprintf(svg_font_out, svg_svg_fnt2);

	fclose(svg_font_out);
	printf("\n");

	fclose(map_file_in);
	return 0;
}

LOCAL int processline(char dd[INPBUF]) {
	char fnt_tmp[WORDLEN];
	int jj = 0;
	int ii = 0;
	int kk = 0;
	while(dd[ii] != '\0') {
		jj = 0;
/* debug
		printf("%2d ", ii);
 */
		if(dd[ii] != '"') {
			while(dd[ii] != ' ' && dd[ii] != '\t' && dd[ii] != '\0') {
				fnt_tmp[jj] = dd[ii];
				jj++;
				ii++;
			}
			fnt_tmp[jj] = '\0';
/* debug
			printf("'%s'\n", fnt_tmp);
 */

/* pfb */
			fnt_pfb[0] == '\0';
			if(fnt_tmp[0] == '<') {
				kk = 1;
				while(fnt_tmp[kk] != '.' && fnt_tmp[kk] != '\0') {
					kk++;
				}
				if(fnt_tmp[kk+1] == 'p' && fnt_tmp[kk+2] == 'f'
				   && fnt_tmp[kk+3] == 'b') {
					kk = 0;
					while(fnt_tmp[kk] != '\0') {
						fnt_pfb[kk] = fnt_tmp[kk+1];
						kk++;
					}
				}
			}
/* pfb */
		}
/* quotes */
		else {
			ii++;
			while(dd[ii] != '"' && dd[ii] != '\0') {
				fnt_tmp[jj] = dd[ii];
				jj++;
				ii++;
			}
			ii++;
			fnt_tmp[jj] = '\0';
/* debug
			printf("quotes:'%s'\n", fnt_tmp);
 */
		}
/* quotes */
		if(dd[ii] != '\0') ii++;
	}
}

LOCAL int psmap(char *srchfnt, FILE *in, FILE *log_out) {
	char dd[INPBUF];
	int ii, jj;

	fseek(in, 0, SEEK_SET);
	while((dd[0]=getc(in)) != EOF) {
		if(dd[0] != '\n') {
			ii = 1;	
			while((dd[ii]=getc(in)) != '\n') ii++;
			dd[ii] = '\0';
			if(COMCOND) {
				ii = 0;
				while(dd[ii] != ' ') {
					fnt_dvi[ii] = dd[ii];
					ii++;
				}
				fnt_dvi[ii] = '\0';
				ii++;
				jj = 0;
				while(dd[ii] != ' ') {
					fnt_ps[jj] = dd[ii];
					ii++;
					jj++;
				}
				fnt_ps[jj] = '\0';
				if(strcmp(fnt_dvi, srchfnt) == 0) {
					fprintf(log_out, "\npsmap: '%s'\n", dd);
					processline(dd);
					fprintf(log_out,
							"psmap: fnt_dvi='%s' fnt_ps='%s' fnt_pfb='%s'\n",
						    fnt_dvi, fnt_ps, fnt_pfb);
					return 1;
				}
			}
		}
	}
	return 0;
}

LOCAL int
svgfontgen(char *f2s_file_enc, char *f2s_enc,
		   char *f2s_sym, char *f2s_prg, char *f2s_font_out, FILE *log_out) {
	char gsexec[MAXGSEXEC];
	char fnt_pfb_path[MAXPATH];
	char gs[] = "gs -q" 
            " -dNODISPLAY -dBATCH -dNOPAUSE -dQUIT"
            " -sFONTFILE=\"%s\" -dTHEFONT=\"/%s\" -sSYMBOLS=\"[ %s ]\""
            " -dENCODING=\"/%s\" -sENCFILE=\"%s\""
            " -sFONTOUT=\"%s\""
			" %s";
/* if founded fnt_dvi, fnt_ps, fnt_pfb */
	if(kpse_find_file(fnt_pfb, kpse_type1_format, true) == NULL) {
		printf("\nCan not find PFB font.\n", fnt_pfb);
		return 1;
	}
	strcpy(fnt_pfb_path, kpse_find_file(fnt_pfb, kpse_type1_format, true));
	fprintf(log_out, "== %s %s\n", fnt_pfb, fnt_pfb_path);
	sprintf(gsexec, gs, fnt_pfb_path, fnt_dvi, f2s_sym,
                f2s_enc, f2s_file_enc, f2s_font_out, f2s_prg);
	fprintf(log_out, "\n%s", gsexec);
	fflush(stdout);
	system(gsexec);
	return 0;
}


/*
 *   SVGFONTS section
 * vim:set ts=4:
 */
