/*
 *	svgout
 */

#include <stdio.h>
#include "dvicom.h"
#include "dvistr.h"
#include "xmlsvg.h"

#define GLOBAL extern
#define LOCAL static

#define STRBUF 4096

#define HORIGIN 72.27
#define VORIGIN 72.27

/* from dvibase.h */
GLOBAL float unit_pt;

LOCAL char *conv(unsigned char *instr) {
	static char unicstr[STRBUF*5];
	int pp = 0, ss = 0;
#include "svgout.h" 		/* T1toUTF8_2, T1toUTF8_3 */
	while(instr[pp] != '\0') {
		if(instr[pp] < 0x20) {
/*
			if(instr[pp] > 0x0a && instr[pp] < 0x10) {
				unicstr[ss] = T1toUTF8_3[instr[pp]-0x0b][0];
				unicstr[ss+1] = T1toUTF8_3[instr[pp]-0x0b][1];
				unicstr[ss+2] = T1toUTF8_3[instr[pp]-0x0b][2];
				ss+=3;
			}
*/
			/*
			   00 01 02  03  04
			   ff fi fl ffi ffl
			      02 03
			*/
			if(instr[pp] == 0x02) {
				unicstr[ss] = T1toUTF8_3[1][0];
				unicstr[ss+1] = T1toUTF8_3[1][1];
				unicstr[ss+2] = T1toUTF8_3[1][2];
				ss+=3;
			}
			else if(instr[pp] == 0x03) {
				unicstr[ss] = T1toUTF8_3[2][0];
				unicstr[ss+1] = T1toUTF8_3[2][1];
				unicstr[ss+2] = T1toUTF8_3[2][2];
				ss+=3;
			}
			else {
				printf("Warning: conv()");
				unicstr[ss] = instr[pp];
				ss++;
			}
		}
		else if(instr[pp] < 0x80) {
			if(instr[pp] == '<') {
				unicstr[ss] = '&';
				unicstr[ss+1] = 'l';
				unicstr[ss+2] = 't';
				unicstr[ss+3] = ';';
				ss+=4;
			}
			else if(instr[pp] == '>') {
				unicstr[ss] = '&';
				unicstr[ss+1] = 'g';
				unicstr[ss+2] = 't';
				unicstr[ss+3] = ';';
				ss+=4;
			}
			else if(instr[pp] == '&') {
				unicstr[ss] = '&';
				unicstr[ss+1] = 'a';
				unicstr[ss+2] = 'm';
				unicstr[ss+3] = 'p';
				unicstr[ss+4] = ';';
				ss+=5;
			}
			else {
				unicstr[ss] = instr[pp];
				ss++;
			}
		}
		else {
			/*
			printf("\n0x%2x: 0x%2x 0x%2x", instr[pp],
				T1toUTF8_2[instr[pp]-0x80][0],
				T1toUTF8_2[instr[pp]-0x80][1]);
			*/
			unicstr[ss] = T1toUTF8_2[instr[pp]-0x80][0];
			unicstr[ss+1] = T1toUTF8_2[instr[pp]-0x80][1];
			ss+=2;
		}
		pp++;
	}
	unicstr[ss] = '\0';
	return (char *) unicstr;
}

int svgout(int c, int d, int e, dvi_state_struct state, int bfrchrstate,
	       FILE *svg_out, FILE *log_out) {

	static unsigned char SM_state = 0;
	static char str[STRBUF];
	static int strl = 0;
	static int fstchrstateh, fstchrstatev;

	switch(SM_state) {
		case 0:
			if(c == DVI_BOP) {
				fprintf(svg_out, svg_text_id, d);
				SM_state = 1;
			}
			break;
		case 1:
			if((c >= DVI_FNT_NUM_0 && c <= DVI_FNT_NUM_63)
			    || (c == DVI_FNT_1)) {
				fprintf(svg_out, svg_tspan_fnt, d);
				SM_state = 2;
			}
			break;
		case 2:
			if(c == DVI_EOP) {
				fprintf(svg_out, svg_text2);
				SM_state = 0;
			}
			else if((c >= DVI_SET_CHAR_0 && c <= DVI_SET_CHAR_127)
			    || (c == DVI_SET_1) || (c == DVI_PUT_1)) {
				fstchrstateh = bfrchrstate;
				fstchrstatev = state.v;
				str[strl] = d;
				str[strl+1] = '\0';
				strl++;
				fprintf(log_out, "SM=(%s)", str);
				SM_state = 3;
			}
			break;
		case 3:
			if(c == DVI_EOP) {
				fprintf(svg_out, svg_tspan_xy, (fstchrstateh * unit_pt) + HORIGIN, (fstchrstatev * unit_pt) + VORIGIN, conv(str));
				strl = 0;
				str[strl] = '\0';
				fprintf(svg_out, svg_tspan2);
				fprintf(svg_out, svg_text2);
				SM_state = 0;
			}
			else if((c >= DVI_FNT_NUM_0 && c <= DVI_FNT_NUM_63)
			    || (c == DVI_FNT_1)) {
				fprintf(svg_out, svg_tspan2);
				fprintf(svg_out, svg_tspan_fnt, d);
				SM_state = 2;
			}
			else if((c >= DVI_SET_CHAR_0 && c <= DVI_SET_CHAR_127)
			    || (c == DVI_SET_1) || (c == DVI_PUT_1)) {
				str[strl] = d;
				/* fprintf(log_out, "SM=[%c]", d); */
				str[strl+1] = '\0';
				strl++;
				fprintf(log_out, "SM=(%s)", str);
				SM_state = 3;
			}
			else if(c >= DVI_RIGHT_1 && c <= DVI_Z_4) {
				fprintf(svg_out, svg_tspan_xy, (fstchrstateh * unit_pt) + HORIGIN, (fstchrstatev * unit_pt) + VORIGIN, conv(str));
				strl = 0;
				str[strl] = '\0';
				SM_state = 4;
			}
			break;
		case 4:
			if(c == DVI_EOP) {
				fprintf(svg_out, svg_text2);
				SM_state = 0;
			}
			else if((c >= DVI_FNT_NUM_0 && c <= DVI_FNT_NUM_63)
			    || (c == DVI_FNT_1)) {
				fprintf(svg_out, svg_tspan2);
				fprintf(svg_out, svg_tspan_fnt, d);
				SM_state = 2;
			}
			else if((c >= DVI_SET_CHAR_0 && c <= DVI_SET_CHAR_127)
			    || (c == DVI_SET_1) || (c == DVI_PUT_1)) {
				fstchrstateh = bfrchrstate;
				fstchrstatev = state.v;
				str[strl] = d;
				str[strl+1] = '\0';
				strl++;
				fprintf(log_out, "SM=(%s)", str);
				SM_state = 3;
			}
			if(c >= DVI_RIGHT_1 && c <= DVI_Z_4)
				SM_state = 4;
			break;
		}
	fprintf(log_out, "\nSM=<%d>",SM_state);
	if(c == DVI_SET_RULE || c == DVI_PUT_RULE)
		fprintf(svg_out, svg_rect_wh, d, e);
}
